//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "BinaryImage0.h"
#include <JPEG.hpp>
#include <math.h>
#include <DateUtils.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void toGray(TImage *image)
{ Byte * ptr;
  int r, g, b, gray, index;

  image->Picture->Bitmap->PixelFormat = pf24bit;
  for (int row=0; row<image->Picture->Height; row++)
     { ptr = (Byte*) image->Picture->Bitmap->ScanLine[row];
       index = 0;
       for (int col=0; col<image->Picture->Width; col++)
          { b = ptr[index  ];
            g = ptr[index+1];
            r = ptr[index+2];
            gray = 0.299*r + 0.587*g + 0.114*b;
            ptr[index  ] = (Byte)gray;
            ptr[index+1] = (Byte)gray;
            ptr[index+2] = (Byte)gray;
            index += 3;
          }
     }
}
void to2D(TImage *image)
{ Byte **ptr;
  int r, g, b, gray, index;

  image->Picture->Bitmap->PixelFormat = pf24bit;
  ptr = new Byte*[image->Picture->Height];
  for (int k=0; k<image->Picture->Height; k++)
     ptr[k] = (Byte*) image->Picture->Bitmap->ScanLine[k];
  for (int row=0; row<image->Picture->Height; row++)
     { index = 0;
       for (int col=0; col<image->Picture->Width; col++)
          { b = ptr[row][index  ];
            g = ptr[row][index+1];
            r = ptr[row][index+2];
            gray = 0.299*r + 0.587*g + 0.114*b;
            ptr[row][index  ] = (Byte)gray;
            ptr[row][index+1] = (Byte)gray;
            ptr[row][index+2] = (Byte)gray;
            index += 3;
          }
     }
  delete [] ptr;
}
void JpgToBmp(TImage *image)
{ Graphics::TBitmap *bmp = new Graphics::TBitmap();

  bmp->Width  = image->Picture->Width;
  bmp->Height = image->Picture->Height;
  bmp->Canvas->Draw(0,0,image->Picture->Graphic);
  image->Picture->Bitmap->Assign(bmp);
  image->Refresh();

  delete bmp;
}

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  DoubleBuffered = true;
  JpgToBmp(Image1);
  Image2->Left = Image1->Width + 2;
  Image2->Top = 1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Load1Click(TObject *Sender)
{
  if ( OpenDialog1->Execute() )
    { Image1->Picture->LoadFromFile(OpenDialog1->FileName);
      Image1->Top  = 1;
      Image1->Left = 1;
      Graphics::TBitmap *bmp = new Graphics::TBitmap();
      bmp->Width  = Image1->Picture->Width;
      bmp->Height = Image1->Picture->Height;
      bmp->Canvas->Draw(0,0,Image1->Picture->Graphic);
      Image1->Picture->Bitmap->Assign(bmp);
      Image1->Refresh();
      Image2->Top = 1;
      Image2->Left = Image1->Width + 2;
      delete bmp;
    }
}
//---------------------------------------------------------------------------
const int RED   = 2;
const int GREEN = 1;
const int BLUE  = 0;

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  float gray;
  int threshold;
  Byte *ptr1, *ptr2, value;
  int index;
  Graphics::TBitmap *mBmp = Image1->Picture->Bitmap;
  Graphics::TBitmap *bmp  = Image2->Picture->Bitmap;

  toGray(Image1);
  mBmp->PixelFormat = pf24bit;
  bmp->PixelFormat  = pf24bit;
  bmp->Width  = mBmp->Width;
  bmp->Height = mBmp->Height;
  threshold = UpDown1->Position;

  for (int y = 0; y < mBmp->Height; y++)
    { ptr1 = (Byte *) mBmp->ScanLine[y];
      ptr2 = (Byte *)  bmp->ScanLine[y];
      index=0;
      for (int x = 0; x < mBmp->Width; x++)
         { if ( ptr1[index]>threshold )
             value = 255;  // pixelȬ۷1
           else value = 0; // pixelȬ۷0
           ptr2[index+  RED] = value;
           ptr2[index+GREEN] = value;
           ptr2[index+ BLUE] = value;
           index += 3;
         }
    }
  Image2->Refresh();  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SaveasBMP1Click(TObject *Sender)
{
  SaveDialog1->Filter = "*.bmp";
  SaveDialog1->DefaultExt = "bmp";
  if ( SaveDialog1->Execute() )
    { if ( FileExists(SaveDialog1->FileName) )
        { int ans = MessageDlg(SaveDialog1->FileName+" exists, overwirte it?",
                           mtWarning, TMsgDlgButtons() << mbYes << mbNo, 0);
          if ( ans==mrNo ) return;
        }
      Image2->Picture->SaveToFile(SaveDialog1->FileName);
      //ShowMessage("File has successfully saved!");
    }
}
//---------------------------------------------------------------------------
void saveAsJpeg(TImage *image, AnsiString fileName, int quality=95)
{ if ( FileExists(fileName) )
    { int ans = MessageDlg(fileName+" exists, overwirte it?",
                           mtWarning, TMsgDlgButtons() << mbYes << mbNo, 0);
      if ( ans==mrNo ) return;
    }

  if ( quality>100 )
    quality = 100;
  else if ( quality<1 )
    quality = 1;

  //Requires "jpeg.hpp" to be included into the source file
  TJPEGImage *jp = new TJPEGImage();
  try
  { jp->Assign(image->Picture->Bitmap);
    jp->CompressionQuality = quality;
    jp->SaveToFile(fileName);
  }
  __finally
  {
    delete jp;
  }
}

void __fastcall TForm1::SaveasJPEG1Click(TObject *Sender)
{
  SaveDialog1->Filter = "*.jpg";
  SaveDialog1->DefaultExt = "jpg";  // ".jpg" will get one more dot.
  if ( SaveDialog1->Execute() )
    { AnsiString InputString = InputBox("Compression Quality",
                                        "Input the quality value between 1..100",
                                        "95");
      int quality = StrToInt(InputString);
      saveAsJpeg(Image2, SaveDialog1->FileName, quality);
    }
}
//---------------------------------------------------------------------------
void toFloydSteinberg(TImage *image1, TImage *image2, float threshold, float gray=255)
{ int row, col, K, mWidth, mHeight;
  float delta, *image;
  BYTE *ptr;
  unsigned long index=0L;
  Graphics::TBitmap *mBmp = image1->Picture->Bitmap;

  mWidth  = mBmp->Width;
  mHeight = mBmp->Height;
  // read image data into image
  image = new float[mWidth*mHeight];
  index = 0L;
  for (row=0; row<mHeight; ++row)
    { ptr = (BYTE *) mBmp->ScanLine[row];
      for (col=0; col<mWidth; ++col)
         {
           image[index+col] = ptr[3*col];
         }
      index += mWidth;
    }
  K=threshold;
  index = 0L;
  for (row=0; row<mHeight-1; ++row)
     { for (col=1; col<mWidth-1; ++col)
          { delta=image[index+col];
            if ( delta>=threshold )
              { image[index+col]=gray;
                delta-=K;
              }
            else image[index+col]=0;
            image[index+col+1        ]+=delta*7./16.;
            image[index+col+mWidth   ]+=delta*5./16.;
            image[index+col+mWidth+1 ]+=delta   /16.;
            image[index+col+mWidth-1 ]+=delta*3./16;
          }
       index+=mWidth;
     }
  for (col=0; col<mWidth; ++col)
     { if ( image[index+col]>=threshold )
         image[index+col]=gray;
       else image[index+col]=0;
     }
  index=0L;
  for (row=0; row<mHeight-1; ++row)
     { if ( image[index]>=threshold )
         image[index]=gray;
       else image[index]=0;
       if ( image[index+mWidth-1]>=threshold )
         image[index+mWidth-1]=gray;
       else image[index+mWidth-1]=0;
       index+=mWidth;
     }
  // save the image to image2
  image2->Picture->Bitmap->Height = image1->Picture->Bitmap->Height;
  image2->Picture->Bitmap->Width  = image1->Picture->Bitmap->Width;
  image2->Picture->Bitmap->PixelFormat = pf24bit;
  mBmp = image2->Picture->Bitmap;
  index = 0L;
  BYTE color;
  for (row=0; row<mHeight; ++row)
    { ptr = (BYTE *) mBmp->ScanLine[row];
      for (col=0; col<mWidth; ++col)
         { if ( image[index+col]!=0.0 )
             color = 255;  // pixelȬ۷1
           else color = 0; // pixelȬ۷0
           ptr[3*col+RED  ] = color;
           ptr[3*col+GREEN] = color;
           ptr[3*col+BLUE ] = color;
         }
      index += mWidth;
    }
  image2->Refresh();

  delete [] image;
}

void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
  int gray=255, threshold = UpDown1->Position;

  toGray(Image1);
  toFloydSteinberg(Image1, Image2, threshold, gray);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormResize(TObject *Sender)
{
  Panel1->Left = ClientWidth  - Panel1->Width  - 2;
  Panel1->Top  = ClientHeight - Panel1->Height - 2;
}
//---------------------------------------------------------------------------

